<template>
  <JDialogConfirm>
    <template #title>
      <div class="title-wrapper">
        <ConversationRoomAvatar
          v-if="chat.type === ChatTypes.Group"
          avatar-size="xs"
          :chat="chat"
        />
        <UserProfileMenu
          v-else-if="chat.interlocutor"
          avatar-size="xs"
          :user="chat.interlocutor"
        >
          <UserProfile :user="chat.interlocutor" />
        </UserProfileMenu>
        <span class="ml-2"> {{ $t('remove_chat_title') }} </span>
      </div>
    </template>
    <template #body>
      {{ $t('remove_chat_body') }}
      <div class="d-flex">
        <ConversationName
          :chat="chat"
          class="conversation-name"
        />
        <span class="question">?</span>
      </div>
    </template>
    <template #actions="{ setFocus }">
      <JButton
        type="normal"
        size="xs"
        @click="$dialog.closeModal"
      >
        {{ $t('no_cancel') }}
      </JButton>
      <JButton
        :ref="(el) => setFocus(el)"
        size="xs"
        class="ml-2"
        @click="
          deletePrivateChat(chat.id);
          deleteChatFromStore(chat.id);
          $dialog.closeModal();
        "
      >
        {{ $t('yes_delete') }}
      </JButton>
    </template>
  </JDialogConfirm>
</template>

<script setup lang="ts">
import { PropType } from 'vue';
import { JDialogConfirm, JButton } from '@new-jira-clone/ui/src/components';
import { UserProfile, UserProfileMenu } from '@/features/user-profile';
import {
  ConversationRoomAvatar,
  ConversationName,
  useConversationStateService,
} from '@/entities/Conversation';
import { useChatSocket } from '@/shared/api';
import { ChatTypes, IChat } from '@/shared';

defineProps({
  chat: {
    type: Object as PropType<IChat>,
    required: true,
  },
});

const { deletePrivateChat } = useChatSocket();
const { deleteChat: deleteChatFromStore } = useConversationStateService();
</script>

<style lang="scss" scoped>
.title-wrapper {
  display: flex;
  align-items: center;
}

.conversation-name {
  max-width: 400px;
  font-size: inherit;
}

.question {
  margin-left: 4px;
  font-weight: 600;
}
</style>
